.nolist
#include <avr/io.h>
#include "param.h"

.list

.section .bss

XStart:		.ds.b	1
YCnt:		.ds.b	1

#define	R_RAS	r3
#define	R_CAS	r4
#define	R_RAS_W	r5
#define	R_CAS_W r6

.section .text
.global SIG_OUTPUT_COMPARE2A
SIG_OUTPUT_COMPARE2A:
	push	r16
	in r16, _SFR_IO_ADDR(SREG)
	sbi _SFR_IO_ADDR(PORTB), LCD_LP
	push	r16
	push	r19
	push	r20
	cbi _SFR_IO_ADDR(PORTB), LCD_LP

	ldi		r19,	C_CP
	ldi		r20, ((XSIZE/4)+XOScan)-1

	cbi		_SFR_IO_ADDR(PORTC), LCD_FLM

	cbi		_SFR_IO_ADDR(PORTC), RAM_A7
	lds		r16,	YCnt							// Zeilenadresse laden
	sbrc	r16,7
	sbi		_SFR_IO_ADDR(PORTC), RAM_A7

	lsl		r16
	out		_SFR_IO_ADDR(PORTD),	r16				// ROW Adresse auf Port ausgeben
	lds		r16,	viewstart						// Spalten start Adresse laden
	add		r20,	r16								// Spalten ende berechnen
	lsl		r16
	lsl		r20
	out		_SFR_IO_ADDR(PORTB),	R_RAS			//RAS Signal
	cbi		_SFR_IO_ADDR(PORTC),	RAM_A7

Xshift:						
	out		_SFR_IO_ADDR(PORTB),	R_RAS			//RAS Signal
	out		_SFR_IO_ADDR(PORTD),	r16				//Column Adresse auf Port ausgeben
	out		_SFR_IO_ADDR(PORTB),	R_CAS			//CAS Signal
	subi	r16, -2									//Column Adresse + 2
	out		_SFR_IO_ADDR(PORTB),	r19				//CP Signal (LCD)
//	nop
	out		_SFR_IO_ADDR(PORTB),	R_RAS			//RAS Signal
	out		_SFR_IO_ADDR(PORTD),	r16				//Column Adresse auf Port ausgeben
	out		_SFR_IO_ADDR(PORTB),	R_CAS			//CAS Signal
	subi	r16, -2									//Column Adresse + 2
	out		_SFR_IO_ADDR(PORTB),	r19				//CP Signal (LCD)
//	nop
	out		_SFR_IO_ADDR(PORTB),	R_RAS			//RAS Signal
	out		_SFR_IO_ADDR(PORTD),	r16				//Column Adresse auf Port ausgeben
	out		_SFR_IO_ADDR(PORTB),	R_CAS			//CAS Signal
	subi	r16, -2									//Column Adresse + 2
	out		_SFR_IO_ADDR(PORTB),	r19				//CP Signal (LCD)
//	nop
	out		_SFR_IO_ADDR(PORTB),	R_RAS			//RAS Signal
	out		_SFR_IO_ADDR(PORTD),	r16				//Column Adresse auf Port ausgeben
	out		_SFR_IO_ADDR(PORTB),	R_CAS			//CAS Signal
	subi	r16, -2									//Column Adresse + 2
	out		_SFR_IO_ADDR(PORTB),	r19				//CP Signal (LCD)

	cp		r16,	r20				
	brlo	Xshift

	ldi		r16,	C_norm			
	out		_SFR_IO_ADDR(PORTB),	r16

	lds		r16,	YCnt			// Zeilenadresse laden
	tst		r16
	brne	not_secline
	sbi _SFR_IO_ADDR(PORTC), LCD_FLM
not_secline:

	inc		r16
	cpi		r16,	YSIZE			// Zeilenzhler berechnen
	brlo	not_firstline				// Bildende ?

	wdr
	clr		r16

#if ((defined(COMMAND_TIMEOUT))&&(COMMAND_TIMEOUT>0))
	lds r19, ctimeout
	dec r19
	sts ctimeout, r19
#endif
	
not_firstline:
	sts YCnt, r16

	pop	r20
	pop r19
	pop r16
	out _SFR_IO_ADDR(SREG), r16
	pop r16
reti
//ca 515 takte +10

// -------------------------
// SET Pixel

.global lcd_setpixel		// X: r25:r24  Sonstige register r21,r19
lcd_setpixel:				// Y: r22		
//	ldi r18, hi8(XSIZEV)	// C: r20
//	cpi r24, lo8(XSIZEV)
//	cpc r25, r18
//	brsh exitbit2
//	cpi r22, lo8(YSIZE)
//	brsh exitbit2
	
	push	r19
	push	r21
	push	r22
	push	r24
	push	r25

	mov r21, r24
	andi r21, 3
	ldi r19, 128
	cpi r21, 0
	breq exitshift
shift:						// r19 = 128>>r21
	lsr r19
	dec r21
	brne shift
exitshift:
	lsr r25
	ror r24

	sbrs r20, 7
	rjmp clrpixel
//Set Pixel	
	cli
	sbrc	r22,7
	sbi	_SFR_IO_ADDR(PORTC),	RAM_A7
	lsl	r22
	out	_SFR_IO_ADDR(PORTD),	r22			//	ROW Adresse							
	out _SFR_IO_ADDR(PORTB),	R_RAS		//	RAS	Signal
	cbi	_SFR_IO_ADDR(PORTC),	RAM_A7
	out	_SFR_IO_ADDR(PORTD),	r24			//	Col Adresse
	out	_SFR_IO_ADDR(PORTB),	R_CAS		//	CAS	Signal
	cbi	_SFR_IO_ADDR(PORTC),	Drv_dir		//	B->A
	clr r20
	out	_SFR_IO_ADDR(DDRD),		r20			//	Port als eingang
	cbi	_SFR_IO_ADDR(PORTC),	Drv_E
	nop	
	nop
	nop
	in	r21,	_SFR_IO_ADDR(PIND)			//	Daten lesen
	sbi	_SFR_IO_ADDR(PORTC),	Drv_E
	ldi	r20, 254
	out	_SFR_IO_ADDR(DDRD),		r20			//	Port als ausgang
	sbi	_SFR_IO_ADDR(PORTC),	Drv_dir		//  A->B
	sbi	_SFR_IO_ADDR(PORTB),	RAM_OE	
	cbi	_SFR_IO_ADDR(PORTC),	Drv_E
	or	r19,	r21							//	Bit setzen
	out	_SFR_IO_ADDR(PORTD),	r19			// Daten ausgeben
	cbi	_SFR_IO_ADDR(PORTB),	RAM_WE
	sbi	_SFR_IO_ADDR(PORTC),	Drv_E
	ldi	r19,	C_norm		 
	out	_SFR_IO_ADDR(PORTB),	r19
	sei
	
	rjmp exitbit

//Clear Pixel
clrpixel:					// Clear Pixel
	com	r19
	cli
	sbrc	r22,7
	sbi	_SFR_IO_ADDR(PORTC), RAM_A7
	lsl	r22
	out	_SFR_IO_ADDR(PORTD),	r22			//	ROW Adresse						
	out _SFR_IO_ADDR(PORTB),	R_RAS		//	RAS
	cbi	_SFR_IO_ADDR(PORTC),	RAM_A7	
	out	_SFR_IO_ADDR(PORTD),	r24			//	Col Adresse
	out	_SFR_IO_ADDR(PORTB),	R_CAS		//	CAS
	cbi	_SFR_IO_ADDR(PORTC),	Drv_dir		// B->A
	clr r20
	out	_SFR_IO_ADDR(DDRD),		r20			//	Port als eingang
	cbi	_SFR_IO_ADDR(PORTC),	Drv_E
	nop	
	nop
	nop
	in	r21,	_SFR_IO_ADDR(PIND)			//	Daten lesen
	sbi	_SFR_IO_ADDR(PORTC),	Drv_E
	ldi	r20, 254
	out	_SFR_IO_ADDR(DDRD),		r20			//	Port als ausgang
	sbi	_SFR_IO_ADDR(PORTC),	Drv_dir
	sbi	_SFR_IO_ADDR(PORTB),	RAM_OE	
	cbi	_SFR_IO_ADDR(PORTC),	Drv_E
	and	r19,	r21							//	Bit setzen
	out	_SFR_IO_ADDR(PORTD),	r19			// Daten ausgeben
	cbi	_SFR_IO_ADDR(PORTB),	RAM_WE
	sbi	_SFR_IO_ADDR(PORTC),	Drv_E
	ldi	r19,	C_norm		 
	out	_SFR_IO_ADDR(PORTB),	r19
	sei
exitbit:
	pop	r25
	pop	r24
	pop	r22
	pop	r21
	pop	r19
exitbit2:
ret
//ca 81 takte

//-----------------------
// write byte

.global lcd_writebyteex
lcd_writebyteex:

.global lcd_writebyte		// X: r24		sonstige register r23
lcd_writebyte:				// Y: r22
							// DATA: r20
//	cpi r24, (XSIZEV/8)
//	brsh exitbyte
//	cpi r22, lo8(YSIZE)
//	brsh exitbyte
	push	r22
	push	r23
	push	r24
		
	ldi	r23,	C_CAS_OE
	lsl	r24
	lsl r24

	cli
	sbrc	r22,7
	sbi	_SFR_IO_ADDR(PORTC), RAM_A7
	lsl	r22
	out _SFR_IO_ADDR(PORTD),	r22			//	ROW adresse
	out	_SFR_IO_ADDR(PORTB),	R_RAS_W		//	RAS
	cbi	_SFR_IO_ADDR(PORTC),	RAM_A7		
	out _SFR_IO_ADDR(PORTD),	r24			//	COL Adresse
	cbi	_SFR_IO_ADDR(PORTC),	Drv_E
	out	_SFR_IO_ADDR(PORTB),	r23			//	CAS+OE
	out	_SFR_IO_ADDR(PORTD),	r20			//	Daten auf Port ausgeben
	out	_SFR_IO_ADDR(PORTB),	R_CAS_W		//	CAS_W
	swap	r20
	subi	r24, -2							//	COL adresse +2
	out	_SFR_IO_ADDR(PORTB),	R_RAS_W		//	RAS
	out	_SFR_IO_ADDR(PORTD),	r24			//	COL Adresse
	out	_SFR_IO_ADDR(PORTB),	r23			//	CAS+OE	
	out	_SFR_IO_ADDR(PORTD),	r20			//	Daten auf Port ausgeben
	out	_SFR_IO_ADDR(PORTB),	R_CAS_W		//	CAS_W
	sbi	_SFR_IO_ADDR(PORTC),	Drv_E	
	ldi	r20,	C_norm	
	out	_SFR_IO_ADDR(PORTB),	r20			//	normal zustand
	sei

	
	pop	r24
	pop	r23
	pop	r22
exitbyte:
	ret										//ca 44 takte 

//------------------------
// write char

.global lcd_writechar		// X: r24		sonstige Register	R18,R21
lcd_writechar:				// Y: r22							
//	cpi r24, (XSIZEV/8)		// C: r20
//	brsh exitchar			// TC: r18				
//	cpi r22, lo8(YSIZE)		// BC: r16
//	brsh exitchar
	push	r21
	push	r22
	push	r24
	
	mov ZL, r20	
	ldi ZH, TEXT_Y
	mul ZL, ZH
	movw ZL, r0
	subi ZL, lo8(-(font))
	sbci ZH, hi8(-(font))
	ldi r21, TEXT_Y
	clr	r1

	lsl r24
	lsl r24
	rol r22
	brcc	wk128		//springe wenn kleiner 128
	ori r22, 1
wk128:

	ldi r16,	C_CAS_OE
	ldi	r18,	C_norm

wchar:
	lpm r20, Z+				// Byte laden
	cli
	out _SFR_IO_ADDR(PORTD),	r22			//	ROW adresse
	sbrc	r22,0
	sbi	_SFR_IO_ADDR(PORTC),	RAM_A7
	out	_SFR_IO_ADDR(PORTB),	R_RAS_W		//	RAS
	cbi	_SFR_IO_ADDR(PORTC),	RAM_A7		
	out _SFR_IO_ADDR(PORTD),	r24			//	COL Adresse
	cbi	_SFR_IO_ADDR(PORTC),	Drv_E
	out	_SFR_IO_ADDR(PORTB),	r16			//	CAS+OE
	out	_SFR_IO_ADDR(PORTD),	r20			//	Daten auf Port ausgeben
	out	_SFR_IO_ADDR(PORTB),	R_CAS_W		//	CAS_W
	swap	r20
	subi	r24, -2							//	Col A.	+2
	out	_SFR_IO_ADDR(PORTB),	R_RAS_W		//	RAS
	out	_SFR_IO_ADDR(PORTD),	r24			//	COL Adresse
	out	_SFR_IO_ADDR(PORTB),	r16			//	CAS+OE	
	out	_SFR_IO_ADDR(PORTD),	r20			//	Daten auf Port ausgeben
	out	_SFR_IO_ADDR(PORTB),	R_CAS_W		//	CAS+WE
	sbi	_SFR_IO_ADDR(PORTC),	Drv_E	
	out	_SFR_IO_ADDR(PORTB),	r18			//	normal zustand
	sei
	
	subi	r24,2							//	Col A.	-2
	subi	r22, -2							//	Row A.	+2
	brne	wkk128
	inc r22
wkk128:
	dec r21
	brne wchar
	
	pop	r24
	pop r22
	pop	r21
exitchar:
ret		// 437 takte

//------------------------
// Clear LCD

.global lcd_clear		// 		sonstige Register	R18,R19,R20,R21
lcd_clear:				// 
	
	push	r18
	push	r19
	push	r20
	push	r21
	
	ldi	r18,	C_norm
	ldi	r19,	2
	clr	r20
	clr	r21

	wrow:
	cli
	out _SFR_IO_ADDR(PORTD),	r20			//	ROW adresse
	sbrc	r20,0
	sbi	_SFR_IO_ADDR(PORTC),	RAM_A7

	out	_SFR_IO_ADDR(PORTB),	R_RAS_W		//	RAS
	cbi	_SFR_IO_ADDR(PORTC),	RAM_A7

	out _SFR_IO_ADDR(PORTD),	r21			//	COL Adresse
	out	_SFR_IO_ADDR(PORTB),	R_CAS_W		//	CAS+WE
	add	r21	,r19							//	COL adresse +2
	out	_SFR_IO_ADDR(PORTB),	R_RAS_W		//	RAS
	out _SFR_IO_ADDR(PORTD),	r21			//	COL Adresse
	out	_SFR_IO_ADDR(PORTB),	R_CAS_W		//	CAS+WE
	add	r21	,r19							//	COL adresse +2
	out	_SFR_IO_ADDR(PORTB),	R_RAS_W		//	RAS
	out _SFR_IO_ADDR(PORTD),	r21			//	COL Adresse
	out	_SFR_IO_ADDR(PORTB),	R_CAS_W		//	CAS+WE
	add	r21	,r19							//	COL adresse +2
	out	_SFR_IO_ADDR(PORTB),	R_RAS_W		//	RAS
	out _SFR_IO_ADDR(PORTD),	r21			//	COL Adresse
	out	_SFR_IO_ADDR(PORTB),	R_CAS_W		//	CAS+WE
				
	out	_SFR_IO_ADDR(PORTB),	r18			//	normal zustand
	sei

	add	r21, r19							//	COL adresse +2
	brcc wrow

	clr	r21

	add	r20, r19					//	Row A.	+2
	brcc	wrow

	cpi	r20, 1
	breq	clrend

	ldi	r20, 1
	rjmp wrow

	clrend:
	
	pop	r21
	pop r20
	pop	r19
	pop r18
						//ca 217881 takte
ret
